blob: d85891976b02eac20a99636862110d89c98da5b2 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
Stefan Reinauer074d9132009-09-26 16:43:17 +000018
Stefan Reinauerd7649122015-06-09 11:44:25 -070019cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010020
Martin Roth589ef9d2016-08-11 18:35:06 -060021CROSSGCC_DATE="August 11th, 2016"
22CROSSGCC_VERSION="1.42"
Stefan Reinauer88352d72016-04-06 15:57:03 -070023CROSSGCC_COMMIT=$( git describe )
Stefan Reinauer074d9132009-09-26 16:43:17 +000024
25# default settings
Stefan Reinauer85b07d62015-06-09 14:45:14 -070026PACKAGE=GCC
Stefan Reinauerd7649122015-06-09 11:44:25 -070027TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000028TARGETARCH=i386-elf
Nico Huber32c4a062016-01-25 18:30:57 +010029LANGUAGES=c
Stefan Reinauer074d9132009-09-26 16:43:17 +000030DESTDIR=
Stefan Reinauer85b07d62015-06-09 14:45:14 -070031SAVETEMPS=0
32SKIPPYTHON=1
Nico Huber234d2462016-01-26 16:10:17 +010033BOOTSTRAP=0
Stefan Reinauer074d9132009-09-26 16:43:17 +000034
Stefan Reinauer699ac272015-06-05 12:43:28 -070035# GCC toolchain version numbers
Timothy Pearson96310162015-12-28 22:53:29 -060036GMP_VERSION=6.1.0
Iru Caiae8e3a02016-04-02 10:50:59 +080037MPFR_VERSION=3.1.4
Paul Menzele6619422015-02-23 10:33:59 +010038MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000039LIBELF_VERSION=0.8.13
Iru Caiae8e3a02016-04-02 10:50:59 +080040GCC_VERSION=5.3.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070041GCC_AUTOCONF_VERSION=2.69
Martin Rothbcfa7cc2016-07-14 13:01:37 -060042BINUTILS_VERSION=2.26.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070043GDB_VERSION=7.11
Martin Roth64b35f32015-12-30 15:10:13 -070044IASL_VERSION=20160318
Stefan Reinauer3dc5d072016-04-21 19:29:03 -070045PYTHON_VERSION=3.5.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070046EXPAT_VERSION=2.1.1
Stefan Reinauer14ce2132015-06-05 13:01:13 -070047# CLANG version number
Iru Caiae8e3a02016-04-02 10:50:59 +080048CLANG_VERSION=3.8.0
Martin Roth589ef9d2016-08-11 18:35:06 -060049MAKE_VERSION=4.2.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000050
Stefan Reinauer699ac272015-06-05 12:43:28 -070051# GCC toolchain archive locations
Martin Roth1484c032016-03-08 09:37:14 -070052# These are sanitized by the jenkins toolchain test builder, so if
53# a completely new URL is added here, it probably needs to be added
54# to the jenkins build as well, or the builder won't download it.
Stefan Reinauerd9d21022016-04-21 18:16:30 -070055GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}.tar.xz"
56MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.xz"
Idwer Vollering7962fc72012-10-25 02:14:09 +020057MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000058LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020059GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070060BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010061GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
Patrick Georgi85bb9462016-02-11 17:22:16 +010062IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix2-${IASL_VERSION}.tar.gz"
Patrick Georgi53c388f2015-03-07 09:55:18 +010063PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer498f3d02016-04-21 18:10:15 -070064EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.bz2"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070065# CLANG toolchain archive locations
66LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
67CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
68CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
69CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080070MAKE_ARCHIVE="http://ftpmirror.gnu.org/make/make-${MAKE_VERSION}.tar.bz2"
Stefan Reinauer074d9132009-09-26 16:43:17 +000071
Martin Roth58c68d52016-03-01 15:22:42 -070072ALL_ARCHIVES="$GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
73 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $IASL_ARCHIVE \
74 $PYTHON_ARCHIVE $EXPAT_ARCHIVE $LLVM_ARCHIVE $CFE_ARCHIVE \
75 $CRT_ARCHIVE $CTE_ARCHIVE $MAKE_ARCHIVE"
76
Stefan Reinauer699ac272015-06-05 12:43:28 -070077# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000078GMP_DIR="gmp-${GMP_VERSION}"
79MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000080MPC_DIR="mpc-${MPC_VERSION}"
81LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000082GCC_DIR="gcc-${GCC_VERSION}"
83BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
84GDB_DIR="gdb-${GDB_VERSION}"
Patrick Georgi85bb9462016-02-11 17:22:16 +010085IASL_DIR="acpica-unix2-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010086PYTHON_DIR="Python-${PYTHON_VERSION}"
87EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070088# CLANG toolchain directories
89LLVM_DIR="llvm-${CLANG_VERSION}.src"
90CFE_DIR="cfe-${CLANG_VERSION}.src"
91CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
92CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080093MAKE_DIR="make-${MAKE_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000094
Patrick Georgi6321f522015-02-27 23:36:26 +010095unset MAKELEVEL MAKEFLAGS
96
Patrick Georgi1861ff72011-10-31 12:15:55 +010097red='\033[0;31m'
98RED='\033[1;31m'
99green='\033[0;32m'
100GREEN='\033[1;32m'
101blue='\033[0;34m'
102BLUE='\033[1;34m'
103cyan='\033[0;36m'
104CYAN='\033[1;36m'
105NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +0000106
zbaoe05c1ea2015-08-05 23:10:05 -0400107UNAME=$(uname | grep -iq cygwin && echo Cygwin || uname)
Martin Roth88463822016-01-07 11:03:36 -0700108HALT_FOR_TOOLS=0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700109
Patrick Georgi198d23c2012-12-08 08:02:44 +0100110normalize_dirs()
111{
112 mkdir -p $DESTDIR$TARGETDIR/lib
113 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
114 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
115 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
116
117 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
118 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
119}
120
Stefan Reinauer93a96302015-06-15 12:36:53 -0700121please_install()
122{
Martin Roth88463822016-01-07 11:03:36 -0700123 HALT_FOR_TOOLS=1
Patrick Georgi5da95dc2015-07-17 23:33:05 +0200124 test -r /etc/os-release && . /etc/os-release
Stefan Reinauer93a96302015-06-15 12:36:53 -0700125 case "$ID_LIKE" in
126 debian) solution="sudo apt-get install $1" ;;
127 suse) solution="sudo zypper install $1" ;;
128 *) solution="using your OS packaging system" ;;
129 esac
130
Martin Roth591790f2016-03-20 20:39:04 -0600131 printf "${RED}ERROR:${red} Missing tool: Please install \'$1\'. (eg $solution)${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700132 if [ -n "$2" ]; then
Martin Roth591790f2016-03-20 20:39:04 -0600133 printf "${RED}ERROR:${red} or install \'$2\'.${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700134 fi
Stefan Reinauer93a96302015-06-15 12:36:53 -0700135}
136
Patrick Georgib7062882015-02-24 10:52:14 +0100137searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000138{
139 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100140 # $2 search string
141 # $3 soft fail if set
Martin Rothe3963172016-01-06 13:54:32 -0700142 # $4 alternative package to install on failure
Patrick Georgib7062882015-02-24 10:52:14 +0100143 # result: file name of that tool on stdout
144 # or no output if nothing suitable was found
145 search=GNU
146 if [ -n "$2" ]; then
147 search="$2"
148 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000149 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700150 if [ -x "$(which $i 2>/dev/null)" ]; then
151 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
152 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000153 echo $i
154 return
155 fi
156 fi
157 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800158 # A workaround for OSX 10.9 and some BSDs, whose nongnu
159 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200160 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100161 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700162 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800163 echo $1
164 return
165 fi
166 fi
167 fi
zbao5cf758d2015-09-01 22:28:57 -0400168 if echo $1 | grep -q "sum" ; then
169 algor=$(echo $1 | sed -e 's,sum,,')
170 if [ -x "$(which $1 2>/dev/null)" ]; then
171 #xxxsum [file]
172 echo $1
173 return
174 elif [ -x "$(which $algor 2>/dev/null)" ]; then
175 #xxx [file]
176 echo $algor
177 return
178 elif [ -x "$(which openssl 2>/dev/null)" ]; then
179 #openssl xxx [file]
180 echo openssl $algor
181 return
182 elif [ -x "$(which cksum 2>/dev/null)" ]; then
183 #cksum -a xxx [file]
184 #cksum has special options in NetBSD. Actually, NetBSD will use the second case above.
185 echo "buildgcc" | cksum -a $algor > /dev/null 2>/dev/null && \
186 echo cksum -a $algor
187 return
zbao939dc842015-04-30 04:44:07 +0800188 fi
189 fi
Martin Rothe3963172016-01-06 13:54:32 -0700190
Martin Roth88463822016-01-07 11:03:36 -0700191 [ -z "$3" ] && please_install $1 $4
Patrick Georgib7062882015-02-24 10:52:14 +0100192 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000193}
194
Martin Roth591790f2016-03-20 20:39:04 -0600195# Run a compile check of the specified library option to see if it's installed
196check_for_library() {
197 local LIBRARY_FLAGS=$1
Aaron Durbin0ac4e5a2016-04-07 16:56:25 -0500198 local LIBRARY_PACKAGES="$2"
Martin Roth591790f2016-03-20 20:39:04 -0600199 local LIBTEST_FILE=.libtest
200
201 echo "int main(int argc, char **argv) { (void) argc; (void) argv; return 0; }" > "${LIBTEST_FILE}.c"
202
203 cc $CFLAGS $LIBRARY_FLAGS "${LIBTEST_FILE}.c" -o "${LIBTEST_FILE}" >/dev/null 2>&1 || \
204 please_install "$LIBRARY_PACKAGES"
205 rm -rf "${LIBTEST_FILE}.c" "${LIBTEST_FILE}"
206}
207
zbao06e85ac2015-08-24 22:08:36 -0400208check_sum() {
209 test -z "$CHECKSUM" || \
210 test "$(cat sum/$1.cksum 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')" = \
211 "$($CHECKSUM tarballs/$1 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')"
212}
213
214compute_sum() {
215 test ! -f sum/$1.cksum && test -f tarballs/$1 && \
216 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$1 > sum/$1.cksum ) && \
217 printf "(checksum created. ${RED}Note. Please upload sum/$1.cksum if the corresponding archive is upgraded.)${NC}"
218}
219
zbao282dd952015-09-06 05:00:04 -0400220download_showing_percentage() {
221 url=$1
222 printf " ..${red} 0%%"
223 wget --no-check-certificate $url 2>&1 | while read line; do
zbao282dd952015-09-06 05:00:04 -0400224 echo $line | grep -o "[0-9]\+%" | awk '{printf("\b\b\b\b%4s", $1)}'
zbao282dd952015-09-06 05:00:04 -0400225 done
Zheng Baobb003c82016-08-05 13:41:51 +0800226 printf "${NC}"
zbao282dd952015-09-06 05:00:04 -0400227}
228
Stefan Reinauer88935482015-06-05 09:51:10 -0700229download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700230 package=$1
231 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700232
Stefan Reinauerd7649122015-06-09 11:44:25 -0700233 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700234 printf " * $FILE "
235
zbaod22b9ea2015-08-30 23:35:16 -0400236 if test -f tarballs/$FILE && check_sum $FILE ; then
237 printf "(cached)"
238 else
Paul Menzelb2ba3952015-06-12 11:58:14 +0200239 printf "(downloading from $archive)"
Stefan Reinauer88935482015-06-05 09:51:10 -0700240 rm -f tarballs/$FILE
241 cd tarballs
zbao282dd952015-09-06 05:00:04 -0400242 download_showing_percentage $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700243 cd ..
zbao06e85ac2015-08-24 22:08:36 -0400244 compute_sum $FILE
zbaod22b9ea2015-08-30 23:35:16 -0400245 fi
246
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700247 if [ ! -f tarballs/$FILE ]; then
zbao282dd952015-09-06 05:00:04 -0400248 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700249 exit 1
250 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700251 printf "\n"
252}
253
254unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700255 package=$1
256 archive="$(eval echo \$$package"_ARCHIVE")"
257 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700258 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700259 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700260 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700261 suffix=$(echo $archive | sed 's,.*\.,,')
Martin Roth95f7b222016-03-20 12:38:48 -0600262 if [ "$suffix" = "gz" ] && [ -n "$PIGZ" ]; then FLAGS="-I pigz -xf"
263 elif [ "$suffix" = "gz" ]; then FLAGS=zxf
264 elif [ "$suffix" = "bz2" ] && [ -n "$LBZIP2" ]; then FLAGS="-I lbzip2 -xf"
265 elif [ "$suffix" = "bz2" ]; then FLAGS=jxf
266 elif [ "$suffix" = "xz" ]; then FLAGS="--xz -xf"
267 elif [ "$suffix" = "lzma" ]; then FLAGS="--lzma -xf"
268 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700269 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700270 for patch in patches/${dir}_*.patch; do
271 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700272 printf " o $(basename $patch)\n"
Nico Huber4b48ed82016-07-27 00:28:03 +0200273 (cd ${dir} && $PATCH -s -N -p1 <../${patch}) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700274 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700275 exit 1
276 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700277 done
278 touch ${dir}/.unpack_success
279 )
280}
281
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700282fn_exists()
283{
Patrick Georgic8665912015-06-11 21:04:31 +0200284 type $1 >/dev/null 2>&1
Patrick Georgi74c06422015-03-25 18:40:13 +0100285}
286
Patrick Georgif2c15f52015-06-11 21:07:31 +0200287is_package_enabled()
288{
289 echo "$PACKAGES" |grep -q "\<$1\>"
290}
291
Martin Roth444ece22016-04-01 18:46:29 -0600292package_uses_targetarch()
293{
Stefan Reinauera344b682016-04-21 19:29:51 -0700294 if [ "$1" = "GCC" ] || [ "$1" = "GDB" ] || [ "$1" = "BINUTILS" ]; then
Martin Roth444ece22016-04-01 18:46:29 -0600295 true
296 else
297 false
298 fi
299}
300
Nico Huber11ea2b32016-01-26 16:09:31 +0100301generic_build()
302{
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700303 package=$1
Nico Huber11ea2b32016-01-26 16:09:31 +0100304 host_target=$2
305 builddir=$3
306 success=$4
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700307
308 fn_exists build_$package || return
309
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700310 version="$(eval echo \$$package"_VERSION")"
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700311
Nico Huber11ea2b32016-01-26 16:09:31 +0100312 mkdir -p "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700313
Nico Huber11ea2b32016-01-26 16:09:31 +0100314 if [ -f "$success" ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700315 printf "Skipping $package as it is already built\n"
316 else
317 printf "Building $package $version ... "
Nico Huber11ea2b32016-01-26 16:09:31 +0100318 DIR="$PWD"
319 cd "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700320 rm -f .failed
Nico Huber11ea2b32016-01-26 16:09:31 +0100321 build_${package} $host_target > build.log 2>&1
322 cd "$DIR"
323 if [ ! -f "$builddir/.failed" ]; then
324 touch "$success";
325 else
326 printf "${RED}failed${NC}. Check $builddir/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700327 exit 1
328 fi
329 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700330 fi
331}
332
Nico Huber11ea2b32016-01-26 16:09:31 +0100333build_for_host()
334{
335 generic_build $1 host build-$1 "${TARGETDIR}/.$1.success"
336}
337
338build_for_target()
339{
340 generic_build $1 target build-${TARGETARCH}-$1 "${TARGETDIR}/.${TARGETARCH}-$1.success"
341}
342
343build()
344{
345 if package_uses_targetarch $1; then
Nico Huber234d2462016-01-26 16:10:17 +0100346 if [ $BOOTSTRAP -eq 1 -a ! -f "${TARGETDIR}/.GCC.success" ]; then
347 build_for_host GCC
348 fi
Nico Huber11ea2b32016-01-26 16:09:31 +0100349 build_for_target $1
350 else
351 build_for_host $1
352 fi
353}
354
Zheng Baobb003c82016-08-05 13:41:51 +0800355quit()
356{
357 printf "${NC}Stop\n"
358 exit 1
359}
360
Stefan Reinauer074d9132009-09-26 16:43:17 +0000361cleanup()
362{
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700363 if [ $SAVETEMPS -ne 0 ]; then
364 printf "Leaving temporary files around... ${green}ok${NC}\n"
365 return
366 fi
367
Stefan Reinauer074d9132009-09-26 16:43:17 +0000368 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700369 for package in $PACKAGES; do
Martin Roth444ece22016-04-01 18:46:29 -0600370 rm -rf build-${TARGETARCH}-$package build-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700371 done
zbaoff3f15c2015-08-26 22:00:31 -0400372 rm -f getopt
Stefan Reinauer074d9132009-09-26 16:43:17 +0000373 printf "${green}ok${NC}\n"
374}
375
376myhelp()
377{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700378 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000379 printf " $0 [-V|--version]\n"
380 printf " $0 [-h|--help]\n\n"
381
382 printf "Options:\n"
383 printf " [-V|--version] print version number and exit\n"
384 printf " [-h|--help] print this help and exit\n"
385 printf " [-c|--clean] remove temporary files before build\n"
386 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100387 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Martin Roth4a53db02016-03-01 15:21:07 -0700388 printf " [--nocolor] don't print color codes in output\n"
Martin Roth58c68d52016-03-01 15:22:42 -0700389 printf " [--urls] print the urls for all packages\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000390 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600391 printf " [-s]--supported <tool> print supported version of a tool\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000392 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600393 printf " (defaults to $TARGETDIR)\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000394 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100395 printf " (for RPM builds, default unset)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700396 printf " [-P|--package <package>] Build a specific package: GCC, CLANG, IASL, GDB\n"
397 printf " (defaults to $PACKAGE)\n"
398 printf "GCC specific options:\n"
Nico Huber234d2462016-01-26 16:10:17 +0100399 printf " [-b|--bootstrap] bootstrap the host compiler before building\n"
400 printf " the cross compiler\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700401 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
402 printf " (defaults to $TARGETARCH)\n"
Nico Huberbb313bf2015-09-08 12:30:27 +0200403 printf " [-l|--languages <languages>] comma separated list of target languages\n"
404 printf " (defaults to $LANGUAGES)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700405 printf "GDB specific options:\n"
406 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
407 printf " (defaults to $TARGETARCH)\n"
408 printf " [-S|--scripting] build scripting support for GDB\n\n"
Martin Rothd1da74f2015-06-21 12:06:28 -0600409 printf "Platforms for GCC & GDB:\n"
Martin Roth3e0f74d2016-03-08 12:07:04 -0700410 printf " x86_64 i386-elf i386-mingw32 mipsel-elf riscv-elf arm aarch64\n"
Jonathan Neuschäferf14f6402016-03-11 20:22:23 +0100411 printf " powerpc64le-linux-gnu nds32le-elf\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000412}
413
Martin Rothedf965a2015-11-25 16:58:33 -0700414printversion() {
415 printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
416}
417
Stefan Reinauer074d9132009-09-26 16:43:17 +0000418myversion()
419{
Martin Rothedf965a2015-11-25 16:58:33 -0700420 printversion
Stefan Reinauer074d9132009-09-26 16:43:17 +0000421
422 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000423Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600424Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000425
426This program is free software; you can redistribute it and/or modify
427it under the terms of the GNU General Public License as published by
428the Free Software Foundation; version 2 of the License.
429
430This program is distributed in the hope that it will be useful,
431but WITHOUT ANY WARRANTY; without even the implied warranty of
432MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
433GNU General Public License for more details.
434
435EOF
436}
437
Nico Huber5f72f962016-01-31 23:05:19 +0100438have_hostcflags_from_gmp() {
439 grep -q __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h >/dev/null 2>&1
440}
441
442set_hostcflags_from_gmp() {
443 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
444 # as GCC 4.6.x fails if it's there.
445 export HOSTCFLAGS=$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
446 sed s,-pedantic,,)
447}
448
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700449build_GMP() {
Paul Kocialkowski7899db22016-06-17 21:41:00 -0700450 CC="$CC" ../${GMP_DIR}/configure --disable-shared --enable-fat \
Nico Huber5f72f962016-01-31 23:05:19 +0100451 --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700452 || touch .failed
453 $MAKE $JOBS || touch .failed
454 $MAKE install DESTDIR=$DESTDIR || touch .failed
455
456 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700457
Nico Huber5f72f962016-01-31 23:05:19 +0100458 set_hostcflags_from_gmp
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700459}
460
461build_MPFR() {
462 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
463 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
464 --infodir=$TARGETDIR/info \
465 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
466 touch .failed
467 $MAKE $JOBS || touch .failed
468 $MAKE install DESTDIR=$DESTDIR || touch .failed
469
470 normalize_dirs
471
472 # work around build problem of libgmp.la
473 if [ "$DESTDIR" != "" ]; then
474 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
475 fi
476}
477
478build_MPC() {
479 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
480 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
481 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
482 touch .failed
483 $MAKE $JOBS || touch .failed
484 $MAKE install DESTDIR=$DESTDIR || touch .failed
485
486 normalize_dirs
487}
488
489build_LIBELF() {
490 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
491 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
492 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
493 $MAKE $JOBS || touch .failed
494 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
495
496 normalize_dirs
497}
498
499build_BINUTILS() {
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700500 if [ $TARGETARCH == "x86_64-elf" ]; then
501 ADDITIONALTARGET=",i386-elf"
502 fi
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700503 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700504 --target=${TARGETARCH} --enable-targets=${TARGETARCH}${ADDITIONALTARGET} \
505 --disable-werror --disable-nls --enable-lto --enable-gold \
Stefan Reinauer2fe2d3d2016-04-05 02:14:48 -0700506 --enable-interwork --enable-multilib \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700507 --enable-plugins --enable-multilibs CFLAGS="$HOSTCFLAGS" || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700508 $MAKE $JOBS || touch .failed
509 $MAKE install DESTDIR=$DESTDIR || touch .failed
510}
511
Nico Huber234d2462016-01-26 16:10:17 +0100512bootstrap_GCC() {
513 CC="$CC" \
514 CFLAGS="$HOSTCFLAGS" \
515 CFLAGS_FOR_BUILD="$HOSTCFLAGS" \
516 CFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
517 CXXFLAGS="$HOSTCFLAGS" \
518 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" \
519 CXXFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
520 ../gcc-${GCC_VERSION}/configure \
521 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
522 --enable-bootstrap \
523 --disable-werror --disable-nls \
524 --disable-shared --disable-multilib \
525 --disable-libssp --disable-libquadmath --disable-libcc1 \
526 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
527 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
528 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
529 --with-pkgversion="coreboot bootstrap v$CROSSGCC_VERSION $CROSSGCC_DATE" \
530 && \
531 $MAKE $JOBS BOOT_CFLAGS="$HOSTCFLAGS" BUILD_CONFIG="" bootstrap && \
532 $MAKE install-gcc \
533 install-target-libgcc \
534 maybe-install-target-libada \
535 maybe-install-target-libstdc++-v3 \
536 DESTDIR=$DESTDIR && \
537 ln -s gcc $DESTDIR$TARGETDIR/bin/cc || touch .failed
538}
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700539
Nico Huber234d2462016-01-26 16:10:17 +0100540build_cross_GCC() {
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700541 # Work around crazy code generator in GCC that confuses CLANG.
Aaron Durbinb2229dc2016-04-07 16:58:10 -0500542 $CC --version | grep clang >/dev/null 2>&1 && \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700543 HOSTCFLAGS="$HOSTCFLAGS -fbracket-depth=1024"
544
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700545 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
546 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700547 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
548 # but it does not seem to work properly. At least the host library
549 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700550 # Also set the CXX version of the flags because GCC is now compiled
551 # using C++.
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100552 CC="$CC" CFLAGS_FOR_TARGET="-O2 -Dinhibit_libc" CFLAGS="$HOSTCFLAGS" \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700553 CFLAGS_FOR_BUILD="$HOSTCFLAGS" CXXFLAGS="$HOSTCFLAGS" \
554 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700555 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
556 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700557 --enable-lto --enable-plugins --enable-gold --enable-ld=default \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700558 --disable-libssp --disable-bootstrap --disable-nls \
559 --disable-libquadmath --without-headers \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100560 --disable-threads \
Patrick Georgi1fc02d12016-03-23 21:44:43 +0100561 --enable-interwork --enable-multilib --enable-targets=all \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100562 --disable-libatomic --disable-libcc1 --disable-decimal-float \
Nico Huberbb313bf2015-09-08 12:30:27 +0200563 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
Ronald G. Minnich7ee16b72016-02-12 21:54:59 +0000564 --with-system-zlib \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700565 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
566 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
567 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
568 || touch .failed
569 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
570 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
571
Stefan Reinauerd7649122015-06-09 11:44:25 -0700572 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700573 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
574 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
575 fi
576}
577
Nico Huber234d2462016-01-26 16:10:17 +0100578build_GCC() {
579 if [ "$1" = host ]; then
580 bootstrap_GCC
581 else
582 build_cross_GCC
583 fi
584}
585
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700586build_EXPAT() {
587 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauera344b682016-04-21 19:29:51 -0700588 --prefix=$TARGETDIR || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700589 $MAKE || touch .failed
590 $MAKE install DESTDIR=$DESTDIR || touch .failed
591
592 normalize_dirs
593}
594
595build_PYTHON() {
596 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauera344b682016-04-21 19:29:51 -0700597 || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700598 $MAKE $JOBS || touch .failed
599 $MAKE install DESTDIR=$DESTDIR || touch .failed
600
601 normalize_dirs
602}
603
604build_GDB() {
605 export PYTHONHOME=$DESTDIR$TARGETDIR
606 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
607 LIBDL="-ldl"
608 fi
609 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
610 -lpthread $LIBDL -lutil" \
611 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700612 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700613 --target=${TARGETARCH} --disable-werror --disable-nls
614 $MAKE $JOBS || touch .failed
615 $MAKE install DESTDIR=$DESTDIR || touch .failed
616}
617
618build_IASL() {
619 RDIR=$PWD
620 cd ../$IASL_DIR/generate/unix
621 CFLAGS="$HOSTCFLAGS"
622 HOST="_LINUX"
623 test $UNAME = "Darwin" && HOST="_APPLE"
624 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
625 test $UNAME = "Cygwin" && HOST="_CYGWIN"
Martin Roth6f656132015-12-08 11:14:10 -0700626 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2 -D COREBOOT_TOOLCHAIN_VERSION='\"coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE\"' " CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700627 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
628 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
629}
630
631build_LLVM() {
632 cd ..
633 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
634 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
635 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
636 cd -
637
638 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
Martin Rothfb5647a2015-12-18 09:26:45 -0700639 -DCLANG_VENDOR="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE - " \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700640 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
641 $MAKE $JOBS || touch .failed
642 $MAKE install || touch .failed
643
644 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
645 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
Stefan Reinauere9e6e3d2015-07-07 00:20:42 +0200646
647 # create symlinks to work around broken --print-librt-file-name
648 # when used with -target.
649 cd $DESTDIR$TARGETDIR/lib/clang/${CLANG_VERSION}/lib
650 for i in */libclang_rt.builtins*.a; do
651 ln -s $i .
652 done
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700653}
654
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800655build_MAKE() {
656 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${MAKE_DIR}/configure --prefix=$TARGETDIR \
657 --disable-nls || touch .failed
658 $MAKE $JOBS || touch .failed
659 $MAKE install DESTDIR=$DESTDIR || touch .failed
660
661 normalize_dirs
662}
663
Martin Rothedf965a2015-11-25 16:58:33 -0700664print_stable() {
665 case "$PRINTSTABLE" in
666 AUTOCONF|autoconf) printf "%s\n" "$GCC_AUTOCONF_VERSION";;
667 BINUTILS|binutils) printf "%s\n" "$BINUTILS_VERSION";;
668 CLANG|clang) printf "%s\n" "$CLANG_VERSION";;
669 EXPAT|expat) printf "%s\n" "$EXPAT_VERSION";;
670 GCC|gcc) printf "%s\n" "$GCC_VERSION";;
671 GDB|gdb) printf "%s\n" "$GDB_VERSION";;
672 GMP|gmp) printf "%s\n" "$GMP_VERSION";;
673 IASL|iasl) printf "%s\n" "$IASL_VERSION";;
674 LIBELF|libelf) printf "%s\n" "$LIBELF_VERSION";;
675 MPC|mpc) printf "%s\n" "$MPC_VERSION";;
676 MPFR|mpfr) printf "%s\n" "$MPFR_VERSION";;
677 PYTHON|python) printf "%s\n" "$PYTHON_VERSION";;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800678 MAKE|make) printf "%s\n" "$MAKE_VERSION";;
Martin Rothedf965a2015-11-25 16:58:33 -0700679 *) printf "Unknown tool %s\n" "$PRINTSTABLE";;
680 esac
681}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000682
Zheng Baobb003c82016-08-05 13:41:51 +0800683trap quit 1 2 3 15
684
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000685# Look if we have getopt. If not, build it.
686export PATH=$PATH:.
687getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
688
Stefan Reinauer074d9132009-09-26 16:43:17 +0000689# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700690getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200691if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000692 # Detected GNU getopt that supports long options.
Nico Huber234d2462016-01-26 16:10:17 +0100693 args=$(getopt -l version,help,clean,directory:,bootstrap,platform:,languages:,package:,jobs:,destdir:,savetemps,scripting,ccache,supported: Vhcd:bp:l:P:j:D:tSys: -- "$@")
Stefan Reinauer074d9132009-09-26 16:43:17 +0000694 eval set "$args"
695else
696 # Detected non-GNU getopt
Nico Huber234d2462016-01-26 16:10:17 +0100697 args=$(getopt Vhcd:bp:l:P:j:D:tSys: $*)
Stefan Reinauer074d9132009-09-26 16:43:17 +0000698 set -- $args
699fi
700
701if [ $? != 0 ]; then
702 myhelp
703 exit 1
704fi
705
706while true ; do
707 case "$1" in
708 -V|--version) shift; myversion; exit 0;;
709 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100710 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000711 -t|--savetemps) shift; SAVETEMPS=1;;
712 -d|--directory) shift; TARGETDIR="$1"; shift;;
Nico Huber234d2462016-01-26 16:10:17 +0100713 -b|--bootstrap) shift; BOOTSTRAP=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000714 -p|--platform) shift; TARGETARCH="$1"; shift;;
Nico Huberbb313bf2015-09-08 12:30:27 +0200715 -l|--languages) shift; LANGUAGES="$1"; shift;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000716 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000717 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700718 -P|--package) shift; PACKAGE="$1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100719 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100720 -y|--ccache) shift; USECCACHE=1;;
Martin Rothedf965a2015-11-25 16:58:33 -0700721 -s|--supported) shift; PRINTSTABLE="$1"; shift;;
Martin Roth58c68d52016-03-01 15:22:42 -0700722 --urls) shift; printf "%s\n" "$ALL_ARCHIVES"; exit 0;;
Martin Roth4a53db02016-03-01 15:21:07 -0700723 --nocolor) shift; \
724 unset red RED green GREEN blue BLUE cyan CYAN NC;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200725 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000726 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200727 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000728 esac
729done
730
Martin Rothedf965a2015-11-25 16:58:33 -0700731if [ -n "$PRINTSTABLE" ]; then
732 print_stable
733 exit 0
734fi
735
736#print toolchain builder version string as the header
737printversion
738
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700739case "$TARGETARCH" in
Timothy Pearsona9f62352015-12-30 18:59:00 -0600740 x86_64-elf) ;;
741 x86_64*) TARGETARCH=x86_64-elf;;
742 i386-elf) ;;
743 i386-mingw32) ;;
744 mipsel-elf) ;;
Iru Caiae8e3a02016-04-02 10:50:59 +0800745 riscv-elf) TARGETARCH=riscv64-elf;;
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100746 powerpc64*-linux*) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600747 i386*) TARGETARCH=i386-elf;;
Stefan Reinauer27522ad2016-01-29 17:31:34 -0800748 arm*) TARGETARCH=arm-eabi;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600749 aarch64*) TARGETARCH=aarch64-elf;;
Martin Roth3e0f74d2016-03-08 12:07:04 -0700750 nds32le-elf) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600751 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700752esac
753
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700754# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700755
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700756case "$PACKAGE" in
757 GCC|gcc)
758 echo "Target architecture is now $TARGETARCH"
759 NAME="${TARGETARCH} cross GCC"
Stefan Reinauerbd8b2e32015-06-17 11:55:02 -0700760 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700761 ;;
762 GDB|gdb)
763 NAME="${TARGETARCH} cross GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700764 if [ $SKIPPYTHON -eq 0 ]; then
Ronald G. Minnichfb944f42016-02-27 04:06:42 +0000765 PACKAGES="EXPAT PYTHON GDB"
766 else
767 PACKAGES="EXPAT GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700768 fi
769 ;;
770 CLANG|clang)
771 NAME=clang
772 PACKAGES="LLVM CFE CRT CTE"
David Hendrickscd5cdd32015-06-15 17:03:22 -0700773 CMAKE=$(searchtool cmake "cmake") || exit $?
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700774 ;;
775 IASL|iasl)
776 NAME="IASL ACPI compiler"
777 PACKAGES=IASL
778 ;;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800779 MAKE|make)
780 NAME="GNU Make"
781 PACKAGES=MAKE
782 ;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700783 *)
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800784 printf "${red}ERROR: Unsupported package $PACKAGE. (Supported packages are GCC, GDB, CLANG, IASL, MAKE)${NC}\n\n";
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700785 exit 1
786 ;;
787esac
Peter Stugeceacd772011-06-09 04:54:16 +0200788
Stefan Reinauer66e93352015-06-16 22:38:23 +0200789# Find all the required tools:
790
791TAR=$(searchtool tar) || exit $?
792PATCH=$(searchtool patch) || exit $?
793MAKE=$(searchtool make) || exit $?
794SHA1SUM=$(searchtool sha1sum)
zbao5cf758d2015-09-01 22:28:57 -0400795#SHA512SUM=$(searchtool sha512sum)
796#MD5SUM=$(searchtool md5sum)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200797CHECKSUM=$SHA1SUM
Martin Roth95f7b222016-03-20 12:38:48 -0600798LBZIP2=$(searchtool lbzip2 "" nofail)
799PIGZ=$(searchtool pigz "" nofail)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200800
801searchtool m4 > /dev/null
802searchtool bison > /dev/null
803searchtool flex flex > /dev/null
804searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Marc Jones5ee69512015-06-17 15:38:17 -0600805searchtool clang "clang version" nofail > /dev/null || \
Martin Rothe3963172016-01-06 13:54:32 -0700806searchtool clang "LLVM" "" "g++" > /dev/null
Stefan Reinauer66e93352015-06-16 22:38:23 +0200807searchtool wget > /dev/null
808searchtool bzip2 "bzip2," > /dev/null
809
Martin Roth591790f2016-03-20 20:39:04 -0600810check_for_library "-lz" "zlib (zlib1g-dev or zlib-devel)"
811
Martin Roth88463822016-01-07 11:03:36 -0700812if [ "$HALT_FOR_TOOLS" -ne 0 ]; then
813 exit 1
814fi
815
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700816# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000817
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700818if [ "$clean" = "1" ]; then
819 cleanup
820fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000821
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700822# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000823
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700824CC=cc
Patrick Georgif2c15f52015-06-11 21:07:31 +0200825if is_package_enabled "GCC"; then
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700826if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000827 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
828
829 # generally the OS X compiler can create x64 binaries.
830 # Per default it generated i386 binaries in 10.5 and x64
831 # binaries in 10.6 (even if the kernel is 32bit)
832 # For some weird reason, 10.5 autodetects an ABI=64 though
833 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700834 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000835 OPTIONS="ABI=64"
836 else
837 OPTIONS="ABI=32"
838 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700839
Stefan Reinauer4266b922012-12-05 16:18:32 -0800840 # In Xcode 4.5.2 the default compiler is clang.
841 # However, this compiler fails to compile gcc 4.7.x. As a
842 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700843 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800844 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700845 fi
zbao11f1d312015-08-05 23:15:54 -0400846elif [ $UNAME = "Linux" -o $UNAME = "Cygwin" ]; then
Patrick Georgiddb8f802015-07-04 17:45:54 +0200847 # gmp is overeager with detecting 64bit CPUs even if they run
848 # a 32bit kernel and userland.
849 if [ "$(uname -m 2>/dev/null)" = "i686" ]; then
850 OPTIONS="ABI=32"
851 fi
Nico Huberde45c592016-01-20 23:22:33 +0100852elif [ $UNAME = "NetBSD" ]; then
853 # same for NetBSD but this one reports an i386
854 if [ "$(uname -m 2>/dev/null)" = "i386" ]; then
855 OPTIONS="ABI=32"
856 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000857fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700858fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000859
Nico Huber5f72f962016-01-31 23:05:19 +0100860export HOSTCFLAGS="-Os"
861if have_hostcflags_from_gmp; then
862 set_hostcflags_from_gmp
863fi
864
Patrick Georgic1a75b12011-11-04 21:37:14 +0100865if [ "$USECCACHE" = 1 ]; then
866 CC="ccache $CC"
867fi
868
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700869# Prepare target directory for building GCC
870# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100871mkdir -p $DESTDIR$TARGETDIR/bin
Stefan Reinauer88352d72016-04-06 15:57:03 -0700872mkdir -p $DESTDIR$TARGETDIR/share
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100873export PATH=$DESTDIR$TARGETDIR/bin:$PATH
874
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700875# Download, unpack, patch and build all packages
876
Martin Roth03625172016-02-17 14:44:14 -0700877printf "Downloading tarballs ... \n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700878mkdir -p tarballs
879for P in $PACKAGES; do
880 download $P
881done
Martin Roth03625172016-02-17 14:44:14 -0700882printf "Downloaded tarballs ... ${green}ok${NC}\n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700883
884printf "Unpacking and patching ... \n"
885for P in $PACKAGES; do
886 unpack_and_patch $P || exit 1
887done
888printf "Unpacked and patched ... ${green}ok${NC}\n"
889
890printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700891for package in $PACKAGES; do
892 build $package
893done
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700894printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700895
Stefan Reinauer699ac272015-06-05 12:43:28 -0700896# Adding git information of current tree to target directory
897# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700898PROGNAME=$(basename "$0")
Stefan Reinauer88352d72016-04-06 15:57:03 -0700899rm -f "$DESTDIR$TARGETDIR/share/$PROGNAME-*"
900cp "$PROGNAME" "$DESTDIR$TARGETDIR/share/$PROGNAME-$CROSSGCC_VERSION-$CROSGCC_COMMIT"
Zheng Bao30b895f2013-02-06 18:04:40 +0800901
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700902cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000903
Stefan Reinauer699ac272015-06-05 12:43:28 -0700904printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"